regina::Script Class Referenceabstract
Basic Packet Types

A packet representing a Python script that can be run. More...

`#include <packet/script.h>`

Inheritance diagram for regina::Script:

## Public Types

typedef Packet | SafePointeeType
| The type of object being pointed to. More...

## Public Member Functions

| Script ()
| Initialises to a script with no text and no variables. More...
const std::string & | text () const
| Returns the complete text of this script. More...
void | setText (const std::string &newText)
| Replaces the complete text of this script with the given string. More...
void | append (const std::string &extraText)
| Adds the given text to the end of this script. More...
size_t | countVariables () const
| Returns the number of variables associated with this script. More...
const std::string & | variableName (size_t index) const
| Returns the name of the requested variable associated with this script. More...
long | variableIndex (const std::string &name) const
| Returns the index of the variable stored with the given name. More...
Packet * | variableValue (size_t index) const
| Returns the value of the requested variable associated with this script. More...
Packet * | variableValue (const std::string &name) const
| Returns the value of the variable stored with the given name. More...
void | setVariableName (size_t index, const std::string &name)
| Changes the name of an existing variable associated with this script. More...
void | setVariableValue (size_t index, Packet *value)
| Changes the value of an existing variable associated with this script. More...
bool | addVariable (const std::string &name, Packet *value)
| Attempts to add a new variable to be associated with this script. More...
const std::string & | addVariableName (const std::string &name, Packet *value)
| Adds a new variable to be associated with this script, changing its name if necessary. More...
void | removeVariable (const std::string &name)
| Removes the variable stored with the given name. More...
void | removeVariable (size_t index)
| Removes the variable stored at the given index. More...
void | removeAllVariables ()
| Removes all variables associated with this script. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
virtual void | packetWasRenamed (Packet *packet)
| Called after the packet label or tags have been changed. More...
virtual void | packetToBeDestroyed (Packet *packet)
| Called before the packet is about to be destroyed. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...
Packet Identification
virtual PacketType | type () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | typeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | label () const
| Returns the label associated with this individual packet. More...
std::string | humanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
std::string | adornedLabel (const std::string &adornment) const
| Returns the label of this packet adorned with the given string. More...
void | setLabel (const std::string &label)
| Sets the label associated with this individual packet. More...
std::string | fullName () const
| Returns a descriptive text string for the packet. More...
Tags
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | tags () const
| Returns the set of all tags associated with this packet. More...
Event Handling
bool | listen (PacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (PacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (PacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
Tree Queries
Packet * | parent () const
| Determines the parent packet in the tree structure. More...
Packet * | firstChild () const
| Determines the first child of this packet in the tree structure. More...
Packet * | lastChild () const
| Determines the last child of this packet in the tree structure. More...
Packet * | nextSibling () const
| Determines the next sibling of this packet in the tree structure. More...
Packet * | prevSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
Packet * | root () const
| Determines the root of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const Packet *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const Packet *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const Packet *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
size_t | countChildren () const
| Returns the number of immediate children of this packet. More...
size_t | countDescendants () const
| Returns the total number of descendants of this packet. More...
size_t | totalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
Tree Manipulation
void | insertChildFirst (Packet *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (Packet *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (Packet *newChild, Packet *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (Packet *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | transferChildren (Packet *newParent)
| Cuts all of this packet's children out of the packet tree, and reinserts them as children of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
Searching and Iterating
Packet * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const Packet * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
Packet * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const Packet * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
Packet * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const Packet * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
Packet * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const Packet * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
Packet Dependencies
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
Cloning
Packet * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
Packet Listener Interface
void | unregisterFromAllPackets ()
| Unregisters this listener from any packets to which it is currently listening. More...
virtual void | packetToBeChanged (Packet *packet)
| Called before the contents of the packet are to be changed. More...
virtual void | packetWasChanged (Packet *packet)
| Called after the contents of the packet have been changed. More...
virtual void | packetToBeRenamed (Packet *packet)
| Called before the packet label or tags are to be changed. More...
virtual void | childToBeAdded (Packet *packet, Packet *child)
| Called before a child packet is to be inserted directly beneath the packet. More...
virtual void | childWasAdded (Packet *packet, Packet *child)
| Called after a child packet has been inserted directly beneath the packet. More...
virtual void | childToBeRemoved (Packet *packet, Packet *child, bool inParentDestructor)
| Called before a child packet is to be removed from directly beneath the packet. More...
virtual void | childWasRemoved (Packet *packet, Packet *child, bool inParentDestructor)
| Called after a child packet has been removed from directly beneath the packet. More...
virtual void | childrenToBeReordered (Packet *packet)
| Called before the child packets directly beneath the packet are to be reordered. More...
virtual void | childrenWereReordered (Packet *packet)
| Called after the child packets directly beneath the packet have been reordered. More...
virtual void | childToBeRenamed (Packet *packet, Packet *child)
| Called before one of this packet's immediate children has its label or tags changed. More...
virtual void | childWasRenamed (Packet *packet, Packet *child)
| Called after one of this packet's immediate children has its label or tags changed. More...

## Static Public Member Functions

static XMLPacketReader * | xmlReader (Packet *parent, XMLTreeResolver &resolver)

## Protected Member Functions

virtual Packet * | internalClonePacket (Packet *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...

## File I/O

bool | save (const char *filename, bool compressed=true) const
| Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format. More...
bool | save (std::ostream &s, bool compressed=true) const
| Writes the subtree rooted at this packet to the given output stream, in the format of a Regina XML data file. More...
void | writeXMLFile (std::ostream &out) const
| Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
bool | hasOwner () const
| Indicates whether some other object in the calculation engine is responsible for ultimately destroying this object. More...
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...

## Detailed Description

A packet representing a Python script that can be run.

A script consists of two parts: (i) the text, which contains the Python code; and (ii) a set of variables, which refer to packets in your packet tree. When running a script, the variables should be instantiated in the default namespace before the script is run.

The values of variables are given by pointers to packets (not packet labels, as in some old versions of Regina). This affects how variables react to changes in the packets that they point to. In particular, if a variable V points to some packet P, then:

- if P is renamed then V will still point to it and the script will notify listeners that the script has changed;
- if P is deleted then V will take the value `None`, and the script will likewise notify listeners of the change.

## Member Typedef Documentation

## SafePointeeType

typedef Packet regina::SafePointeeBase< Packet >::SafePointeeType

inherited

The type of object being pointed to.

## Member Function Documentation

## detail()

std::string regina::Output< Packet , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## str()

std::string regina::Output< Packet , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## utf8()

std::string regina::Output< Packet , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

The documentation for this class was generated from the following file:

- packet/script.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).